Index: main/logger.c
===================================================================
--- main/logger.c	(revision 119891)
+++ main/logger.c	(working copy)
@@ -133,9 +133,9 @@
 	enum logmsgtypes type;
 	char date[256];
 	int level;
-	const char *file;
+	char file[80];
 	int line;
-	const char *function;
+	char function[80];
 	AST_LIST_ENTRY(logmsg) list;
 	char str[0];
 };
@@ -1135,6 +1135,8 @@
 	/* Create a new logging message */
 	if (!(logmsg = ast_calloc(1, sizeof(*logmsg) + res + 1)))
 		return;
+
+	bzero(logmsg, sizeof(*logmsg));
 	
 	/* Copy string over */
 	strcpy(logmsg->str, buf->str);
@@ -1148,9 +1150,9 @@
 
 	/* Copy over data */
 	logmsg->level = level;
-	logmsg->file = file;
+	strncpy(logmsg->file, file, sizeof(logmsg->file)-1);
 	logmsg->line = line;
-	logmsg->function = function;
+	strncpy(logmsg->function, function, sizeof(logmsg->function)-1);
 
 	/* If the logger thread is active, append it to the tail end of the list - otherwise skip that step */
 	if (logthread != AST_PTHREADT_NULL) {
